// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://go.microsoft.com/fwlink/?LinkId=238214.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// CntrItem.h : interface of the CCodeEditorCntrItem class
//

#pragma once

class CCodeEditorDoc;
class CCodeEditorView;

class CCodeEditorCntrItem : public CRichEditCntrItem
{
	DECLARE_SERIAL(CCodeEditorCntrItem)

// Constructors
public:
	CCodeEditorCntrItem(REOBJECT* preo = NULL, CCodeEditorDoc* pContainer = NULL);
		// Note: pContainer is allowed to be NULL to enable IMPLEMENT_SERIALIZE
		//  IMPLEMENT_SERIALIZE requires the class have a constructor with
		//  zero arguments.  Normally, OLE items are constructed with a
		//  non-NULL document pointer

// Attributes
public:
	CCodeEditorDoc* GetDocument()
		{ return reinterpret_cast<CCodeEditorDoc*>(CRichEditCntrItem::GetDocument()); }
	CCodeEditorView* GetActiveView()
		{ return reinterpret_cast<CCodeEditorView*>(CRichEditCntrItem::GetActiveView()); }

// Implementation
public:
	~CCodeEditorCntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

